all: $(BUILDDIR) build

BINDIR  = $(ROOTDIR)/bin
SOURCES = $(CFILES) $(CPPFILES) $(ASFILES)

$(BUILDDIR):
	mkdir -p $(BUILDDIR)

archive: $(ARCHIVE)($(OBJECTS))

.depend:
	$(CC) $(CFLAGS) -M $(SOURCES) > $@

clean:
ifeq ($(USRDLL),y)
	rm -rf $(OBJECTS) *.so
else
	rm -rf $(OBJECTS) *.o *.ko *.o_shipped *.mod.c *~ .*cmd .tmp_versions .depend Module.symvers
	@if [ -f core ]; then rm -f core; fi
endif

ifdef ARCHIVE
	@if [ -f $(ARCHIVE) ]; then \
	rm -f $(ARCHIVE); fi
endif

ifdef NAME
	rm -f $(FXFILES)
endif

ifdef SUBDIRS
	@for X in $(SUBDIRS) ; do \
	cd $$X && make clean && cd ..; \
	done
endif

ifdef GCCDEP
	$(CXX) $(CFLAGS) -M $(CFILES) $(CPPFILES) > $@
endif

subdirs:
	@for X in $(SUBDIRS) ; do \
	cd $$X && make && cd ..; done

OBJECTS = $(CFILES:.c=.o) $(CPPFILES:.cpp=.o) $(ASFILES:.s=.o)

.c.o:
	$(CC) $(CFLAGS) -c $<

.cpp.o:
	$(CXX) $(CFLAGS) $(CPPFLAGS) -c $<
 
.asm.o:
ifeq ($(x86_64), y)
	$(YASM) -m amd64 -f elf $<
else
	$(NASM) -f elf -i $(MATHDIR)/ $<
endif

