/**
*******************************************************************************
Confidential & Proprietary
Private & Confidential
Creative Confidential
*******************************************************************************
*/
/**
*******************************************************************************
Copyright (C) 2007, Creative Technology Ltd. All Rights Reserved.
*******************************************************************************
*/
#ifndef _IASSYSTEM_H
#define _IASSYSTEM_H

#include "ctcomdef.h"
#include "ctdef.h"
#include "IasOSSrv.h"

// added for FEATURESCALE support for LoadDriver
#include "FeatureScale.h"

#include "hwinfo.h"

//#include "ICtDevice.h"


typedef struct _stHardwareInfo
{
    CTDWORD busNum;                     // Bus number - number assigned to this bus on this machine
    CTDWORD funcNum;                    // Unique function number ( used by multifunction cards )
    CTDWORD instance;                   // Instance this bus; ( can be slot number or any unique identifier )
    CTDWORD vendorID;                   // Unique vendor id
    CTDWORD deviceID;                   // Unique device id
    CTDWORD subsys;                     // Unique sub-device id
    CTDWORD rev;                        // Hardware revision code;
	CTTCHAR szCardDesc[CT_CHAR_MAXVAL]; // Card description - filled in ctdevice module
    CTDWORD busType;                    // Bus Type - PCI, USB, 1394, etc
} stHardwareInfo;


typedef struct _stHardwareInfo2
{
    CTDWORD  cbSize;                     // Size of this structure
    CTDWORD  busType;                    // Bus Type - PCI, USB, 1394, etc
    CTDWORD  deviceType;                 // Device Type - Audio, JoyStick and etc
    CTDWORD  busNum;                     // Bus number- number assigned to this bus on this machine;
    CTDWORD  funcNum;                    // Unique function number ( used by multifunction cards )
    CTDWORD  instance;                   // Instance this bus; ( can be slot number or any unique identifier )
    CTDWORD  vendorID;                   // Unique vendor id
    CTDWORD  deviceID;                   // Unique device id
    CTDWORD  subsys;                     // Unique sub-device id
    CTDWORD  rev;                        // Hardware revision code;
    CLSID    HWClassID;                  // HardwareClassID - e.g. CLSID_C10KxAudioHwMgr
    CTTCHAR  szCardDesc[CT_CHAR_MAXVAL]; // Card description - filled in ctdevice module
} stHardwareInfo2;


#define CT_SYSINFO_PHYSPAGESIZE         0x0001 // Expected buffer size is sizeof(CTPTRSIZE)
#define CT_SYSINFO_NUMPHYSPAGES         0x0002 // Expected buffer size is sizeof(CTPTRSIZE)
#define CT_SYSINFO_NUMPROCESSORS        0x0003 // Expected buffer size is sizeof(CTULONG)
#define CT_SYSINFO_ACTIVEPROCESSORS     0x0004 // Expected buffer size is sizeof(CTPTRSIZE). This is a bit mask of active processors.

#define CT_FILE_READ_ACCESS             (1)
#define CT_FILE_WRITE_ACCESS            (2)

#define HSYSCTKEY_ABSOLUTE              ((CTHANDLE)0)   // Path is an absolute registry path
#define HSYSCTKEY_MACHINE               ((CTHANDLE)1)   // Path is relative to \Registry\Machine
#define HSYSCTKEY_ROOT                  ((CTHANDLE)2)   // Path is relative to \Registry\Machine\SOFTWARE\CREAF\EMU10KxUDA


typedef enum {
    ISYSASSET_DWORD,       // CTDWORD type
    ISYSASSET_SZ,          // Null-terminated ASCII string
    ISYSASSET_BINARY       // Size-delimited binary value
} ISYSASSET_TYPE;

#define CT_MEMORY_READ_ACCESS			(1)
#define CT_MEMORY_WRITE_ACCESS			(2)
#define CT_MEMORY_MODIFY_ACCESS			(3)

#define CT_EVENT_ALL_ACCESS     0x001F0003 

//***************
// Guid stuff
//***************
// {0CE0BA21-B239-11d2-9CB4-006097D1FC31}
DEFINE_GUID( IID_IasSystem, 0xce0ba21, 0xb239, 0x11d2, 0x9c, 0xb4, 0x0, 0x60, 0x97, 0xd1, 0xfc, 0x31);

// {A460AB68-0FF5-465c-8D76-45711B90861A}
DEFINE_GUID( IID_IasSystem2, 0xa460ab68, 0xff5, 0x465c, 0x8d, 0x76, 0x45, 0x71, 0x1b, 0x90, 0x86, 0x1a);

// {B4DCF3BF-744C-44a9-87FD-42565605E18A}
DEFINE_GUID( IID_IasSystem3, 0xb4dcf3bf, 0x744c, 0x44a9, 0x87, 0xfd, 0x42, 0x56, 0x56, 0x5, 0xe1, 0x8a);

// {A78411DA-46C1-4613-A532-77A8F9D8A6E7}
DEFINE_GUID(IID_IasSystem4, 0xa78411da, 0x46c1, 0x4613, 0xa5, 0x32, 0x77, 0xa8, 0xf9, 0xd8, 0xa6, 0xe7);

// {CEAB94F0-CED4-40c9-B83D-84B389393CB8}
DEFINE_GUID(IID_IasSystem5, 0xceab94f0, 0xced4, 0x40c9, 0xb8, 0x3d, 0x84, 0xb3, 0x89, 0x39, 0x3c, 0xb8);

// {6BB630CD-A0AB-40e9-B656-BEDDEBAE4C89}
DEFINE_GUID(IID_IasSystem6, 0x6bb630cd, 0xa0ab, 0x40e9, 0xb6, 0x56, 0xbe, 0xdd, 0xeb, 0xae, 0x4c, 0x89);

// {AFEB4EE2-B46B-11d2-9CB4-006097D1FC31}
DEFINE_GUID( CLSID_CtWin95System, 0xafeb4ee2, 0xb46b, 0x11d2, 0x9c, 0xb4, 0x0, 0x60, 0x97, 0xd1, 0xfc, 0x31);

// {DA1A3161-B487-11d2-9CB4-006097D1FC31}
DEFINE_GUID( CLSID_NTSystem, 0xda1a3161, 0xb487, 0x11d2, 0x9c, 0xb4, 0x0, 0x60, 0x97, 0xd1, 0xfc, 0x31);


#undef  INTERFACE
#define INTERFACE IasSystem
//*****************************************************************************
// IasSystem
//*****************************************************************************
DECLARE_INTERFACE_( IasSystem, ICtNondelegatingUnknown )
{
    // ICtNondelegatingUnknown
    IMP_ICTNONDEL;

    //*************************************************************************
    //  PostBootInit initializes system objects and resources that require
    //  the system to be fully booted before instantiation
    //*************************************************************************
    STDMETHOD( PostBootInit ) ( THIS ) PURE;

    //*************************************************************************
    //  Get current system time- The system time is the current
    //  number of milliseconds since the system started.
    //*************************************************************************
    STDMETHOD( GetSystemTime ) ( THIS_ CTDWORD* pTime   ) PURE;

    //**************************************************************************
    //                        Timeout / DPC functions
    // CreateTimeout- creates a timeout object.
    //
    // DestroyTimeout - Destroys a timeout object
    //
    // DestroyTimeout Stops a previously scheduled timeout.
    //
    // ScheduleTimeout schedules a function to execute in the future.
    // This routine schedules functions with a relatively low
    // priority, so it shouldn't be used for things which must
    // execute at precise intervals.  On the other hand, it
    // runs at callback time, so there are no restrictions on
    // what the callback function can do.
    //***************************************************************************
    STDMETHOD ( CreateTimeout   ) ( THIS_ OSTIMEOUTHANDLE *retHandle ) PURE;
    STDMETHOD ( DestroyTimeout  ) ( THIS_ OSTIMEOUTHANDLE ) PURE;
    STDMETHOD ( ScheduleTimeout ) ( THIS_ OSTIMEOUTHANDLE hTimeout,  PFCALLBACK pfCallback,
                                    CTHANDLE hUser, CTDWORD dwMillisecs ) PURE;

    //**************************************************************************
    //                        High-Priority Timeout
    //
    // ScheduleInterruptTimeout schedules a function to execute in the future.
    // This routine schedules functions with an interrupt-time
    // priority, so it shouldn't be used for things which require extensive
    // processing time or paged code segments.  This method does not have
    // an unregister counterpart. Instead, it must be called again after each
    // timeout.  On shutdown, the code must not be unloaded until the callback
    // has been made.
    //
    //***************************************************************************
    STDMETHOD ( CreateInterruptTimeout   ) ( THIS_  OSTIMEOUTHANDLE *retHandle ) PURE;
    STDMETHOD ( DestroyInterruptTimeout  ) ( THIS_ OSTIMEOUTHANDLE ) PURE;
    STDMETHOD ( ScheduleInterruptTimeout ) ( THIS_ OSTIMEOUTHANDLE hTimeout, PFCALLBACK pfCallback,
                                             CTHANDLE hUser, CTDWORD dwMillisecs ) PURE;

    //**************************************************************************
    // CreateDpc- Creates a Dpc object.
    //
    // DestroyDpc - Destroys a Dpc object
    //
    // ScheduleDpc Requests that the OS call the specified routine as soon
    // as possible in a "normal" non-ISR kernel environment
    // The intent of this routine is that it can be called at ISR-time to
    // schedule lower-priority processing in a less restrictive
    // environment.  OS's with no limitations about when routines can
    // be called may turn around and invoke this routine immediately.
    //**************************************************************************
    STDMETHOD ( CreateDpc  )  ( THIS_ OSDPCHANDLE* phDpc ) PURE;
    STDMETHOD ( DestroyDpc )  ( THIS_ OSDPCHANDLE hDpc ) PURE;
    STDMETHOD ( ScheduleDpc ) ( THIS_ OSDPCHANDLE hDpc, PFCALLBACK callback, CTHANDLE hUser ) PURE;

    //*************************************************************************
    //  Register Interrupt-
    //  irqHandle-  pointer to a DWORD to receive a handle.
    //  intNum-     OS assigned interrupt number or resource
    //  dwIsr -     pointer to the function that should be called at
    //              ISR time
    //  dwUser      user data- this data will be passed as a paramater to
    //              the registererd ISR callback
    //*************************************************************************
    STDMETHOD( RegisterInterrupt   ) ( THIS_ CTHANDLE* phIrq,  CTHANDLE hIrqResource,
                                       PF_ISR_CALLBACK pIsrCallback, CTHANDLE hUser ) PURE;
    // unregister previously registered interrupt
    STDMETHOD( UnregisterInterrupt ) ( THIS_ CTHANDLE hIrq ) PURE;

    //*************************************************************************
    //  Start/Stop receiving interrupts
    //*************************************************************************
    STDMETHOD( StartInterrupt ) ( THIS_ CTHANDLE hIrq ) PURE;
    STDMETHOD( StopInterrupt  ) ( THIS_ CTHANDLE hIrq ) PURE;

    //*************************************************************************
    //  AckInterrupt interrupt
    //*************************************************************************
    STDMETHOD( AckInterrupt   ) ( THIS_ CTHANDLE hIrq ) PURE;

    //*************************************************************************
    //  Get hardware info about this device
    //  pInfo- pointer to a stHardwareInfo struct to be filled out by the driver
    //*************************************************************************
    STDMETHOD ( GetHardwareInfo ) ( THIS_ CTHANDLE hDevice, stHardwareInfo* pInfo ) PURE;

    //*************************************************************************
    //  Allocate memory from the heap - locked or unlocked
    //
    //  Heapfree and LockedHeapFree are non-async services. If these functions
    //  are called at a time when non-async services are not allowed,
    //  an error code of E_ASYNC will be returned
    //
    //  Note: HeapAlloc and LockedHeapAlloc are also non-async services, however
    //        if called at a time when non-async services are not available NULL
    //        will be returned- ie there is no specific error code for this case
    //*************************************************************************
    STDMETHOD_( CTVOID*,HeapAllocate       ) ( THIS_ CTDWORD dwSize ) PURE;
    STDMETHOD_( CTVOID*,LockedHeapAllocate ) ( THIS_ CTDWORD dwSize ) PURE;
    STDMETHOD ( HeapFree       ) ( THIS_ CTVOID* pMem   ) PURE;
    STDMETHOD ( LockedHeapFree ) ( THIS_ CTVOID* pMem   ) PURE;

    //**************************************************************************
    //                      Page Allocate Functions
    //
    // AllocPages - Allocates enough OS pages to encompass the number of specified
    // number of bytes.  The range's size is alwayd rounded up to next highest OS
    // page if the number of bytes requested isn't an even multiple of the OS page
    // size.  So, for example, if a user asks for 4096 bytes on a system with 8K
    // pages, they will get back 8K.  In general, a user can assume only that they
    // will get back at least as much memory as they request.  These pages are
    // NOT locked (see LockPages).   If the request fails, 0 is returned.
    // Can only be called at Passive level.
    //
    //
    // AllocContiguousPages - Allocates LOCKED contiguous pages.  As with
    // AllocPages, this routine rounds the number of bytes requested up to
    // the next OS page size.  The pages returned are guaranteed to be both
    // locked and contiguous.  Also, on systems where this is necessary,
    // the pages are mapped into the bus address space.  Passive level only.
    //
    // FreePages - Deallocates pages.  This routine should be called to free
    //  memory that was originally allocated by either AllocPages or
    //  AllocContiguousPages.   Passive level only.
    //
    // LockPages - Locks a page range that was previously allocated by
    //  AllocPages.  Locking a page range accomplishes three things: it
    //  insures that physical pages are committed for the virtual range;
    //  it marks the pages as locked in memory; and it insures that
    //  a mapping of the pages exists in the bus's address space.
    //  Calls to LockPages may be nested; if it is called multiple times,
    //  the pages won't actually be unlocked until UnlockPages is called
    //  an equal number of times.  While it is legal to call LockPages and
    //  UnlockPages on Contiguous page ranges, it has no effect since the
    //  pages are locked at allocation time.   Passive level only.
    //
    // UnlockPages - Decrements the lock count for a page range.  When the
    //  lock count drops to zero, the pages are unlocked.  Once a page range
    //  has been unlocked, calls to GetPageBusAddr and GetPagePhysAddr may
    //  return incorrect values.  Passive level only.
    //
    // GetPageVirtAddr - Returns the virtual address of the first page in
    //  the page range.  Although this return may be called at any call level
    //  (passive, dispatch, or ISR) the virtual address may not be used to
    //  reference memory at a non-passive level unless the page range has been
    //  locked.
    //
    // GetPagePhysAddr - Given a byte offset into the page range, this routine
    //  returns the physical address of byte.  For example, let's suppose that
    //   a 16K page range has been allocated, and that the value returned by
    //   GetPageVirtAddr for this range is 0x40000.  If the client calls
    //   GetPagePhysAddr with an offset of 0x6000, this routine should return
    //   the physical address of the byte at virtual address 0x46000.
    //   For our purposes, a physical address is defined as the address which
    //   is stored in the processor's  PTE entry as part of virtual to physical
    //   translation.  This should not be called unless the page range has been
    //   locked with LockPages.  It may be called at any call level.
    //
    // GetPageBusAddr - Given a byte offset into the page range, this routine
    //  returns the bus address of the byte at that offset.  For our purposes,
    //  a bus address is defined as the address which the sound chip must
    //  issue in order to read or write a particular byte of memory.  On most
    //  Intel systems, GetPagePhysAddr and GetPageBusAddr return the same
    //  value.  On systems which support physical addresses greater than 4 Gigs,
    //  however, it is necessary to map portions of the physical address space
    //  into the bus address space (the Alpha and most SGIs require this,
    //  for example).   This routine will return invalid addresses unless the
    //  page range has been locked.  It may be called at any call level.
    //
    // GetPageRangeSize - Returns the actual size of the page range, in bytes.
    //  The OS is free to return either the value originally requested by the client
    //  or the actual size of the page range, whichever is most convenient.
    //  Clients have to be able to handle values which are larger than they
    //   asked for.   This routine may be called at any call level.
    //
    // FlushPageCache - Performs a cache operation to bring the processor
    //  into synchronization with physical memory on systems which aren't I/O
    //  cache coherent.  A cache invalidate (CTOS_CACHE_INVALIDATE) causes data
    //  currently in the cache to be flushed rather than being written back to
    //  memory.  This type of cache flush should be used before the client
    //  attempts to read data which has been DMA'ed into memory.  A cache
    //  writeback causes any cached data to be written back to physical memory
    //  and should be used after the user has modified data which is being
    //  DMA'ed to the device.  FlushPageCache cannot be called at ISR time.
    //
    //**************************************************************************
    STDMETHOD_( OSPHYSMEMHDL, AllocPages )        ( THIS_ CTDWORD dwNumBytes, CTDWORD dwFlags ) PURE;
    STDMETHOD_( OSPHYSMEMHDL, AllocContiguousPages )( THIS_ CTDWORD dwNumBytes, interface ICtDevice *pDevice) PURE;
    STDMETHOD ( FreePages )                       ( THIS_ OSPHYSMEMHDL memhdl ) PURE;

    STDMETHOD ( LockPages )                       ( THIS_ OSPHYSMEMHDL memhdl ) PURE;
    STDMETHOD ( UnlockPages )                     ( THIS_ OSPHYSMEMHDL memhdl ) PURE;

    STDMETHOD_( OSVIRTADDR, GetPageVirtAddr )     ( THIS_ OSPHYSMEMHDL memhdl ) PURE;
    STDMETHOD_( OSVIRTADDR, GetPageUserModeVirtAddr) (THIS_ OSPHYSMEMHDL memhdl ) PURE;
    STDMETHOD_( OSPHYSADDR, GetPagePhysAddr )     ( THIS_ OSPHYSMEMHDL memhdl, CTDWORD dwOffset) PURE;
    STDMETHOD_( OSBUSADDR,  GetPageBusAddr )      ( THIS_ OSPHYSMEMHDL memhdl, CTDWORD dwOffset, interface ICtDevice * device) PURE;
    STDMETHOD_( CTDWORD, GetPageRangeSize )       ( THIS_ OSPHYSMEMHDL memhdl) PURE;
    STDMETHOD_( CTVOID, FlushPageCache )          ( THIS_ OSPHYSMEMHDL memhdl, CTDWORD dwMode ) PURE;

    //*************************************************************************
    //  map a legacy 16:16 pointer to flat 32bit space. Used in Windows95/98.
    //  The contents of pFlat are stuffed with the mapped pointer.
    //  Linux, NT4, NT5, WDM, BeOs, MacOs, etc are excused and should
    //  set *pFlat to NULL, and return E_FAIL
    //*************************************************************************
    STDMETHOD ( MapFlat16BitPointer )     ( THIS_ CTDWORD p16, CTDWORD* pFlat ) PURE;

    //************************************************************************
    //                     Spinlock Functions
    //
    // Spinlocks can only be used by pagelocked code. In the case of NT,
    // acquiring a spinlock will automatically raise the IRQL to  xxxxxxx,
    // In the case on Windows 9x, interrupts will be disabled.
    //
    //************************************************************************
	STDMETHOD( CreateSpinLock  ) ( THIS_ CTHANDLE* hSpinlock, interface ICtDevice * pDevice ) PURE;
    STDMETHOD( DestroySpinLock ) ( THIS_ CTHANDLE  hSpinlock ) PURE;
    STDMETHOD( AcquireSpinLock ) ( THIS_ CTHANDLE  hSpinlock ) PURE;
    STDMETHOD( ReleaseSpinLock ) ( THIS_ CTHANDLE  hSpinlock ) PURE;

    //**************************************************************************
    //                       Mutex Functions
    //  See IasOSSrv.h for descriptions of these functions
    //**************************************************************************/
    STDMETHOD ( CreateMutex  ) ( THIS_ CTHANDLE *pmutexhdl ) PURE;
    STDMETHOD ( AcquireMutex ) ( THIS_ CTHANDLE mutexhdl   ) PURE;
    STDMETHOD ( ReleaseMutex ) ( THIS_ CTHANDLE mutexhdl   ) PURE;
    STDMETHOD ( WaitMutex    ) ( THIS_ CTHANDLE mutexhdl   ) PURE;
    STDMETHOD ( DeleteMutex  ) ( THIS_ CTHANDLE mutexhdl   ) PURE;

    //*************************************************************************
    //                      Semaphore Functions
    // See IasOSSrv.h for descriptions of these functions
    //*************************************************************************
    STDMETHOD(CreateSemaphore) (THIS_ OSSEMAHDL *phNewSema, CTDWORD dwInitialCount) PURE;
    STDMETHOD(WaitSemaphore) (THIS_ OSSEMAHDL hSema) PURE;
    STDMETHOD(SignalSemaphore) (THIS_ OSSEMAHDL hSema) PURE;
    STDMETHOD(DestroySemaphore) (THIS_ OSSEMAHDL hSema) PURE;

    //*************************************************************************
    //  Kernel mode FILE IO
    //*************************************************************************

    //*************************************************************************
    //  Open or create a file
    //
    //  attribFlags, file access flags- CT_FILE_READ_ACCESS, CT_FILE_WRITE_ACCESS
    //  szFileName-  null terminated string containing the filename
    //  hFile-       address of a void pointer to receive the file handle
    //*************************************************************************
    STDMETHOD ( OpenCreateFile )( THIS_ CTWORD attribFlags, CTPATH *szFileName, CTHANDLE* hFile ) PURE;

    //*************************************************************************
    //  Get the size of a file
    //  pSize- poiunter to a DWORD to receive the size
    //  hFile- file handle
    //*************************************************************************
    STDMETHOD ( GetFileSize )( THIS_ CTDWORD* pSize, CTHANDLE hFile ) PURE;

    //*************************************************************************
    //  WriteFile write to a file
    //
    //  count-   number of bytes to write
    //  pos-     position in the file to start writing-
    //           (offset from the beginning of the file)
    //  pBuffer- pointer to buffer containing data to write
    //  hFile-   file handle
    //*************************************************************************
    STDMETHOD ( WriteFile   )( THIS_ CTDWORD count, CTDWORD pos, const CTBYTE* pBuffer, CTHANDLE hFile, CTDWORD* pdwBytesWritten ) PURE;

    //*************************************************************************
    //  ReadFile read from a file
    //
    //  count-   number of bytes to read
    //  pos-     position in the file to start reading-
    //           (offset from the beginning of the file)
    //  pBuffer- pointer to buffer to receive data
    //  hFile-   file handle
    //*************************************************************************
    STDMETHOD ( ReadFile    )( THIS_ CTDWORD count, CTDWORD pos, CTBYTE* pBuffer, CTHANDLE hFile, CTDWORD* pdwBytesRead ) PURE;

    //*************************************************************************
    // Close the file
    //*************************************************************************
    STDMETHOD ( CloseFile   )( THIS_ CTHANDLE hFile ) PURE;

    //*************************************************************************
    //  Returns the length of the path, considering WideChar or ASCII
	//  system dependencies. Value returned is in NUMBER OF CHARACTERS.
    //*************************************************************************
	STDMETHOD_(CTULONG, GetPathLength) (THIS_ CTPATH *pszString) PURE;

    //*************************************************************************
    //  Returns whether or not the path denoted in pszString is in fact
	//  a full path to a file. If it is just a file name, a partial path
	//  to a file, or a relative path to a file, this will return FALSE.
	//  Otherwise it returns TRUE.
    //*************************************************************************
	STDMETHOD_(CTBOOL,IsFullPath  ) ( THIS_ CTPATH * pszString) PURE;

    //*************************************************************************
    //  Returns whether or not the paths denoted in pszString1 and pszString2
	//  are in fact pointing to the same file. Accounts for case insensitive
	//  file systems and Windows long/short path names in the post-boot INIT
	//  stage.
    //*************************************************************************
	STDMETHOD_(CTBOOL,ArePathsIdentical  ) ( THIS_ CTPATH * pszString1, CTPATH * pszString2) PURE;

	//*************************************************************************
    //  Takes the data in 'pszString', which is assumed to be either an HTML
	//  path or a standard system path to a file, and returns the system
	//  path version of the identical file.
	//  In the case of a case-insensitive operating system, path comes back
	//  in all capital letters. Returns a
	//  pointer to the original string, so it WILL change the data you pass it!
	//  Returns NULL if data in 'pBufSize' is too small to hold the final path,
	//  fills pBufSize with the correct size.
    //*************************************************************************
	STDMETHOD_(CTPATH*,GetSystemStylePathName  ) ( THIS_ CTPATH* pszString, PCTDWORD pBufSize) PURE;

    //*************************************************************************
    //  Get the full path to the driver's "data" directory
	//  This is where static data files should be accessed
    //*************************************************************************
	STDMETHOD ( GetDriverDataDirectory  ) ( THIS_ CTPATH* pszString, CTDWORD bufSize ) PURE;

	//*************************************************************************
    //  Get the full path to the driver's "preferences" directory
	//  This is where backup and temporary storage files should be placed
    //*************************************************************************
	STDMETHOD ( GetDriverPreferenceDirectory  ) ( THIS_ CTPATH* pszString, CTDWORD bufSize ) PURE;

    //*************************************************************************
    //  Returns the single character that delimits directories in the given OS
    //*************************************************************************
	STDMETHOD_(CTPATH, GetPathDelimiter  ) ( THIS ) PURE;

    //*************************************************************************
    //  Returns whether or not the file system differentiates paths by case.
	//  IE Is 'filename' and 'FILENAME' and 'FiLeNaMe' equivilant?
    //*************************************************************************
	STDMETHOD_(CTBOOL, IsFileSystemCaseSensitive  ) ( THIS ) PURE;

    //*************************************************************************
    //  Returns whether or not the file system requires WideChar paths.
    //*************************************************************************
	STDMETHOD_(CTBOOL, IsFileSystemWideChar  ) ( THIS ) PURE;

    //*************************************************************************
    //  Given the path in asciiPath, return the WideChar path equivilant.
	//  'pWideCharPathBufferSize' is the size of the WideChar Path IN BYTES!!!
	//  If that buffer is too small, returns with a null string and fills
	//  pWideCharPathSize with the correct value. If bDoSystemStyle is TRUE,
	//  AND if the system uses WideChar paths, the function
	//  runs the final WideChar path through the function GetSystemStylePathName
    //*************************************************************************
	STDMETHOD (ASCIIPathToWideChar  ) ( THIS_ CTUSHORT *wideCharPath, const CTCHAR *asciiPath, PCTDWORD pWideCharPathBufferSize, CTBOOL bDoSystemStyle) PURE;

	//*************************************************************************
    //  Given the path in 'wideCharPath', return the ASCII path equivilant.
	//  'pAsciiPathBufferSize' is the size of the WideChar Path IN BYTES!!!
	//  If that buffer is too small, returns with a null string and fills
	//  pAsciiPathSize with the correct value. If bDoSystemStyle is TRUE,
	//  AND if the system uses ASCII paths, the function
	//  runs the final WideChar path through the function GetSystemStylePathName
    //*************************************************************************
	STDMETHOD (WideCharPathtoASCII  ) ( THIS_ CTCHAR *asciiPath, const CTUSHORT *wideCharPath, PCTDWORD pAsciiPathBufferSize, CTBOOL bDoSystemStyle) PURE;

    //*************************************************************************
    //  Given the path in asciiPath, return the system path equivilant.
	//  If the system uses ASCII paths, data is left alone, pending state of
	//  pDoSystemStyle, explained below. If the system
	//  uses WideChar paths, data is converted to WideChar.
	//  'pCtPathBufferSize' is the size of the WideChar Path IN BYTES!!!
	//  If that buffer is too small, returns with a null string and fills
	//  pCtPathSize with the correct value. If bDoSystemStyle is TRUE, function
	//  runs the final path through the function GetSystemStylePathName.
    //*************************************************************************
	STDMETHOD (ASCIIPathToCTPATH  ) ( THIS_ CTPATH *ctPath, const CTCHAR *asciiPath, PCTDWORD pCtPathBufferSize, CTBOOL bDoSystemStyle) PURE;

    //*************************************************************************
    //  Given the path in wideCharPath, return the system path equivilant.
	//  If the system uses WideChar paths, data is left alone, pending state of
	//  pDoSystemStyle, explained below. If the system
	//  uses ASCII paths, data is converted to ASCII.
	//  'pCtPathBufferSize' is the size of the WideChar Path IN BYTES!!!
	//  If that buffer is too small, returns with a null string and fills
	//  pCtPathSize with the correct value. If bDoSystemStyle is TRUE, function
	//  runs the final path through the function GetSystemStylePathName.
	//  WARNING WARNING WARNING WARNING WARNING
	//  WARNING WARNING WARNING WARNING WARNING
	//  This code is a format change ONLY, and expectes the wideCharPath to
	//  contain only ASCII (7 bit) data. It will have strange results if you
	//  use true WideChar data on a system that only supports ASCII paths.
	//  WARNING WARNING WARNING WARNING WARNING
	//  WARNING WARNING WARNING WARNING WARNING
    //*************************************************************************
	STDMETHOD (WideCharPathToCTPATH  ) ( THIS_ CTPATH *ctPath, const CTUSHORT *wideCharPath, PCTDWORD pCtPathBufferSize, CTBOOL bDoSystemStyle) PURE;

    //*************************************************************************
    // Math functions
    //*************************************************************************
    STDMETHOD_(double,acos)				(THIS_ double) PURE;
    STDMETHOD_(double,asin)				(THIS_ double) PURE;
    STDMETHOD_(double,atan)				(THIS_ double) PURE;
    STDMETHOD_(double,atan2)			(THIS_ double, double) PURE;
    STDMETHOD_(double,cos)				(THIS_ double) PURE;
    STDMETHOD_(double,cosh)				(THIS_ double) PURE;
    STDMETHOD_(double,exp)				(THIS_ double) PURE;
    STDMETHOD_(double,fabs)				(THIS_ double) PURE;
    STDMETHOD_(double,fmod)				(THIS_ double, double) PURE;
    STDMETHOD_(double,log)				(THIS_ double) PURE;
    STDMETHOD_(double,log10)			(THIS_ double) PURE;
    STDMETHOD_(double,pow)				(THIS_ double, double) PURE;
    STDMETHOD_(double,sin)				(THIS_ double) PURE;
    STDMETHOD_(double,sinh)				(THIS_ double) PURE;
    STDMETHOD_(double,tan)				(THIS_ double) PURE;
    STDMETHOD_(double,tanh)				(THIS_ double) PURE;
    STDMETHOD_(double,sqrt)				(THIS_ double) PURE;
	STDMETHOD_(double,ceil)				(THIS_ double) PURE;
	STDMETHOD_(double,floor)			(THIS_ double) PURE;
	STDMETHOD_(double,frexp)			(THIS_ double, int *) PURE;
	STDMETHOD_(double,ldexp)			(THIS_ double, int) PURE;
	STDMETHOD_(double,modf)				(THIS_ double, double *) PURE;
    STDMETHOD_(double,GetHugeNum)       (THIS) PURE;
    STDMETHOD_(CTBOOL, finite)          (THIS_ double dVal) PURE;
    STDMETHOD_(CTBOOL, isnan)           (THIS_ double dVal) PURE;

    STDMETHOD(GetFPUBufSize)            (THIS_ PCTDWORD pdwBytes) PURE;
    STDMETHOD(SaveFPU)                  (THIS_ PCTVOID pFPUBuffer) PURE;
    STDMETHOD(RestoreFPU)               (THIS_ PCTVOID pFPUBuffer) PURE;

    //*************************************************************************
    // Persistant settings manager methods
    //*************************************************************************
    STDMETHOD(OpenKey)      (THIS_ CTHANDLE hTopKey, const PCTTCHAR pszRelative, PCTHANDLE phKey) PURE;
    STDMETHOD(EnumKey)      (THIS_ CTHANDLE hTopKey, CTDWORD dwInterator, PCTTCHAR pszRelative, CTDWORD dwSize ) PURE;
    STDMETHOD(EnumValue)    (THIS_ CTHANDLE hKey, CTDWORD dwIterator, PCTTCHAR pszValue, PCTDWORD pdwNameSize,
                                   ISYSASSET_TYPE* pType, PCTVOID pBuffer, PCTDWORD pdwDataSize  ) PURE;
    STDMETHOD(QueryValue)   (THIS_ CTHANDLE hKey, PCTTCHAR pszValName, ISYSASSET_TYPE* pType, PCTVOID pBuffer,
                                   PCTDWORD pBufSize ) PURE;
    STDMETHOD(CloseKey)     (THIS_ CTHANDLE hKey) PURE;

    // Setting methods
    STDMETHOD(CreateKey)    (THIS_ CTHANDLE hTopKey, const PCTTCHAR pszRelative, PCTHANDLE phKey) PURE;
    STDMETHOD(SetValue)     (THIS_ CTHANDLE hTopKey, const PCTTCHAR pszValName, ISYSASSET_TYPE type, PCTVOID pBuffer,
                                   CTDWORD dwBufSize ) PURE;

    //*************************************************************************
    // Module loading methods
    //*************************************************************************
    STDMETHOD(LoadModule)       (THIS_ CTPATH*, PCTHANDLE phModule) PURE;
    STDMETHOD(UnloadModule)     (THIS_ CTHANDLE hModule) PURE;
    STDMETHOD(GetProcAddress)   (THIS_ CTHANDLE hModule, PCTCHAR pszFName, PPCTVOID fAddress) PURE;

    //**************************************************************************
    // DisableAllInterrupts disables all interrupts for the current thread
    // on the current processor.  This routine is not intended for synchronization
    // but rather for time critical operations.
    //
    // DisableAllInterrupts will return a handle  When the client calls enable
    // allinterrupts he should pass this handle in as a paramater.
    // Do not call this routine for any reason.
    //
    // EnableAllInterrupts enables interrupts.
    //**************************************************************************/
    STDMETHOD_( CTHANDLE, DisableAllInterrupts ) ( THIS ) PURE;
    STDMETHOD_( CTVOID, EnableAllInterrupts    ) ( THIS_ CTHANDLE h ) PURE;

    //***************************************************************************
    // Atomic operations
    //***************************************************************************
    STDMETHOD_(CTLONG, InterlockedIncrement ) ( THIS_ CTLONG * ) PURE;
    STDMETHOD_(CTLONG, InterlockedDecrement ) (THIS_ CTLONG *) PURE;
};


typedef IasSystem * PASSYSTEM;


#define IMP_IasSystem \
IMP_DECL_ICTNONDEL; \
STDMETHODIMP PostBootInit( );\
STDMETHODIMP CreateTimeout( OSTIMEOUTHANDLE *retHandle );\
STDMETHODIMP DestroyTimeout( OSTIMEOUTHANDLE );\
STDMETHODIMP ScheduleTimeout( OSTIMEOUTHANDLE hTimeout,  PFCALLBACK pfCallback, CTHANDLE hUser, CTDWORD dwMillisecs );\
STDMETHODIMP CreateInterruptTimeout( OSTIMEOUTHANDLE *retHandle );\
STDMETHODIMP DestroyInterruptTimeout( OSTIMEOUTHANDLE );\
STDMETHODIMP ScheduleInterruptTimeout( OSTIMEOUTHANDLE hTimeout, PFCALLBACK pfCallback, CTHANDLE hUser, CTDWORD dwMillisecs );\
STDMETHODIMP CreateDpc( OSDPCHANDLE* phDpc );\
STDMETHODIMP DestroyDpc( OSDPCHANDLE hDpc );\
STDMETHODIMP ScheduleDpc( OSDPCHANDLE hDpc, PFCALLBACK callback, CTHANDLE hUser );\
STDMETHODIMP GetSystemTime( CTDWORD* pTime   );\
STDMETHODIMP RegisterInterrupt  ( CTHANDLE* phIrq, CTHANDLE hIrqResource, PF_ISR_CALLBACK pIsrFunc, CTHANDLE hUser );\
STDMETHODIMP UnregisterInterrupt( CTHANDLE hIrq );\
STDMETHODIMP StartInterrupt( CTHANDLE hIrq );\
STDMETHODIMP StopInterrupt ( CTHANDLE hIrq );\
STDMETHODIMP AckInterrupt  ( CTHANDLE hIrq );\
STDMETHODIMP GetHardwareInfo ( CTHANDLE hDevice, stHardwareInfo* pInfo );\
STDMETHODIMP_( CTVOID* ) HeapAllocate( CTDWORD dwSize );\
STDMETHODIMP_( CTVOID* ) LockedHeapAllocate( CTDWORD dwSize );\
STDMETHODIMP HeapFree( CTVOID* pMem   );\
STDMETHODIMP LockedHeapFree( CTVOID* pMem );\
STDMETHODIMP_( OSPHYSMEMHDL ) AllocPages( CTDWORD dwNumBytes, CTDWORD dwFlags );\
STDMETHODIMP_( OSPHYSMEMHDL ) AllocContiguousPages( CTDWORD dwNumBytes, interface ICtDevice *device);\
STDMETHODIMP  FreePages( OSPHYSMEMHDL memhdl );\
STDMETHODIMP  LockPages( OSPHYSMEMHDL memhdl );\
STDMETHODIMP  UnlockPages( OSPHYSMEMHDL memhdl );\
STDMETHODIMP_( OSVIRTADDR ) GetPageVirtAddr( OSPHYSMEMHDL memhdl );\
STDMETHODIMP_( OSVIRTADDR ) GetPageUserModeVirtAddr( OSPHYSMEMHDL memhdl );\
STDMETHODIMP_( OSPHYSADDR ) GetPagePhysAddr( OSPHYSMEMHDL memhdl, CTDWORD dwOffset);\
STDMETHODIMP_( OSBUSADDR  ) GetPageBusAddr(  OSPHYSMEMHDL memhdl, CTDWORD dwOffset, interface ICtDevice* pDevice);\
STDMETHODIMP_( CTDWORD    ) GetPageRangeSize( OSPHYSMEMHDL memhdl);\
STDMETHODIMP_( CTVOID     ) FlushPageCache( OSPHYSMEMHDL memhdl, CTDWORD dwMode );\
STDMETHODIMP MapFlat16BitPointer( CTDWORD p16, CTDWORD* pFlat );\
STDMETHODIMP CreateSpinLock(  CTHANDLE* hSpinlock, interface ICtDevice* pDevice );\
STDMETHODIMP DestroySpinLock( CTHANDLE  hSpinlock );\
STDMETHODIMP AcquireSpinLock( CTHANDLE  hSpinlock );\
STDMETHODIMP ReleaseSpinLock( CTHANDLE  hSpinlock );\
STDMETHODIMP CreateMutex(  CTHANDLE *pmutexhdl );\
STDMETHODIMP AcquireMutex( CTHANDLE mutexhdl );\
STDMETHODIMP ReleaseMutex( CTHANDLE mutexhdl );\
STDMETHODIMP WaitMutex(    CTHANDLE mutexhdl );\
STDMETHODIMP DeleteMutex(  CTHANDLE mutexhdl );\
STDMETHODIMP CreateSemaphore( OSSEMAHDL *psema, CTDWORD dwInitialCount);\
STDMETHODIMP WaitSemaphore(OSSEMAHDL); \
STDMETHODIMP SignalSemaphore(OSSEMAHDL);\
STDMETHODIMP DestroySemaphore(OSSEMAHDL);\
STDMETHODIMP OpenCreateFile ( CTWORD attrib, CTPATH *pFileName, CTHANDLE* hFile );\
STDMETHODIMP GetFileSize( CTDWORD* pSize, CTHANDLE hFile );\
STDMETHODIMP WriteFile  ( CTDWORD count, CTDWORD pos, const CTBYTE* pBuffer, CTHANDLE hFile, CTDWORD* pdwBytesWritten );\
STDMETHODIMP ReadFile   ( CTDWORD count, CTDWORD pos, CTBYTE* pBuffer, CTHANDLE hFile, CTDWORD* pdwBytesRead );\
STDMETHODIMP CloseFile  ( CTHANDLE hFile );\
STDMETHODIMP_(CTULONG) GetPathLength( CTPATH *pszString); \
STDMETHODIMP_(CTBOOL)  IsFullPath( CTPATH * pszString); \
STDMETHODIMP_(CTBOOL)  ArePathsIdentical( CTPATH * pszString1, CTPATH * pszString2); \
STDMETHODIMP_(CTPATH*) GetSystemStylePathName( CTPATH* pszString, PCTDWORD pBufSize); \
STDMETHODIMP           GetDriverDataDirectory( CTPATH* pszString, CTDWORD bufSize ); \
STDMETHODIMP           GetDriverPreferenceDirectory( CTPATH* pszString, CTDWORD bufSize ); \
STDMETHODIMP_(CTPATH)  GetPathDelimiter( ); \
STDMETHODIMP_(CTBOOL)  IsFileSystemCaseSensitive( ); \
STDMETHODIMP_(CTBOOL)  IsFileSystemWideChar( ); \
STDMETHODIMP           ASCIIPathToWideChar( CTUSHORT *wideCharPath, const CTCHAR *asciiPath, PCTDWORD pWideCharPathBufferSize, CTBOOL bDoSystemStyle); \
STDMETHODIMP           WideCharPathtoASCII( CTCHAR *asciiPath, const CTUSHORT *wideCharPath, PCTDWORD pAsciiPathBufferSize, CTBOOL bDoSystemStyle); \
STDMETHODIMP           ASCIIPathToCTPATH( CTPATH *ctPath, const CTCHAR *asciiPath, PCTDWORD pCtPathBufferSize, CTBOOL bDoSystemStyle); \
STDMETHODIMP           WideCharPathToCTPATH( CTPATH *ctPath, const CTUSHORT *wideCharPath,  PCTDWORD pCtPathBufferSize, CTBOOL bDoSystemStyle);\
STDMETHODIMP_(double) acos   (double);\
STDMETHODIMP_(double) asin	(double);\
STDMETHODIMP_(double) atan	(double);\
STDMETHODIMP_(double) atan2	(double, double);\
STDMETHODIMP_(double) cos	(double);\
STDMETHODIMP_(double) cosh	(double);\
STDMETHODIMP_(double) exp	(double);\
STDMETHODIMP_(double) fabs	(double);\
STDMETHODIMP_(double) fmod	(double, double);\
STDMETHODIMP_(double) log	(double);\
STDMETHODIMP_(double) log10	(double);\
STDMETHODIMP_(double) pow	(double, double);\
STDMETHODIMP_(double) sin	(double);\
STDMETHODIMP_(double) sinh	(double);\
STDMETHODIMP_(double) tan	(double);\
STDMETHODIMP_(double) tanh	(double);\
STDMETHODIMP_(double) sqrt	(double);\
STDMETHODIMP_(double) ceil	(double);\
STDMETHODIMP_(double) floor	(double);\
STDMETHODIMP_(double) frexp	(double, int *);\
STDMETHODIMP_(double) ldexp	(double, int);\
STDMETHODIMP_(double) modf	(double, double *);\
STDMETHODIMP_(double) GetHugeNum();\
STDMETHODIMP_(CTBOOL) finite(double dVal);\
STDMETHODIMP_(CTBOOL) isnan(double dVal);\
STDMETHODIMP GetFPUBufSize  (PCTDWORD pdwBytes);\
STDMETHODIMP SaveFPU        (PCTVOID pFPUBuffer);\
STDMETHODIMP RestoreFPU     (PCTVOID pFPUBuffer);\
STDMETHODIMP OpenKey( CTHANDLE hTopKey, const PCTTCHAR pszRelative, PCTHANDLE phKey );\
STDMETHODIMP EnumKey( CTHANDLE hTopKey, CTDWORD dwInterator, PCTTCHAR pszRelative, CTDWORD dwSize );\
STDMETHODIMP EnumValue( CTHANDLE hKey, CTDWORD dwIterator, PCTTCHAR pszValue, PCTDWORD pdwNameSize,\
                        ISYSASSET_TYPE* pType, PCTVOID pBuffer, PCTDWORD pdwDataSize );\
STDMETHODIMP QueryValue( CTHANDLE hKey, PCTTCHAR pszValName, ISYSASSET_TYPE* pType, PCTVOID pBuffer, \
                         PCTDWORD pBufSize );\
STDMETHODIMP CloseKey( CTHANDLE hKey );\
STDMETHODIMP CreateKey( CTHANDLE hTopKey, const PCTTCHAR pszRelative, PCTHANDLE phKey);\
STDMETHODIMP SetValue( CTHANDLE hTopKey, const PCTTCHAR pszValName, ISYSASSET_TYPE type, PCTVOID pBuffer,\
                       CTDWORD dwBufSize );\
STDMETHODIMP LoadModule(CTPATH*, PCTHANDLE phModule);\
STDMETHODIMP UnloadModule(CTHANDLE hModule);\
STDMETHODIMP GetProcAddress(CTHANDLE hModule, PCTCHAR pszFName, PPCTVOID fAddress);\
STDMETHODIMP_( CTHANDLE ) DisableAllInterrupts();\
STDMETHODIMP_( CTVOID   ) EnableAllInterrupts( CTHANDLE h ); \
STDMETHODIMP_( CTLONG ) InterlockedIncrement( CTLONG * ); \
STDMETHODIMP_( CTLONG ) InterlockedDecrement( CTLONG * )


#undef  INTERFACE
#define INTERFACE IasSystem2
//*****************************************************************************
// IasSystem2
//*****************************************************************************
DECLARE_INTERFACE_( IasSystem2, IasSystem )
{
    STDMETHOD ( GetHardwareInfo2 ) ( THIS_ CTHANDLE hDevice, stHardwareInfo2 * pInfo2 ) PURE;
    STDMETHOD ( LoadDriver ) ( THIS_ REFCLSID DriverClsid, FEATURESCALE featureScale ) PURE;
    STDMETHOD ( UnloadDriver ) ( THIS_ REFCLSID DriverClsid ) PURE;
};


typedef IasSystem2 * PASSYSTEM2;


#define IMP_IasSystem2 \
IMP_IasSystem; \
STDMETHODIMP GetHardwareInfo2 ( CTHANDLE hDevice, stHardwareInfo2 * pInfo2 );\
STDMETHODIMP LoadDriver ( REFCLSID DriverClsid, FEATURESCALE featureScale );\
STDMETHODIMP UnloadDriver ( REFCLSID DriverClsid )


#undef  INTERFACE
#define INTERFACE IasSystem3
//*****************************************************************************
// IasSystem3
//*****************************************************************************
DECLARE_INTERFACE_( IasSystem3, IasSystem2 )
{
    //***************************************************************************
    //                        Timeout / PASSIVE functions
    // CreateNonCriticalTimeout- creates a timeout object, which runs at PASSIVE
    //                           level.
    //
    // DestroyNonCriticalTimeout - Stops a previously scheduled timeout and
    //                             destroys a timeout object
    //
    // ScheduleNonCriticalTimeout - Schedules a function to execute in the future.
    //
    // This routine schedules functions with a lowest priority, so it shouldn't be
    // used for things which must execute at precise intervals.  On the other hand,
    // it runs at PASSIVE callback time, so there are no restrictions on
    // what the callback function can do.
    //***************************************************************************
    STDMETHOD ( CreateNonCriticalTimeout   ) ( THIS_ OSTIMEOUTHANDLE *retHandle ) PURE;
    STDMETHOD ( DestroyNonCriticalTimeout  ) ( THIS_ OSTIMEOUTHANDLE ) PURE;
    STDMETHOD ( ScheduleNonCriticalTimeout ) ( THIS_ OSTIMEOUTHANDLE hTimeout,  PFCALLBACK pfCallback,
                                               CTHANDLE hUser, CTDWORD dwMillisecs ) PURE;

    //***************************************************************************
    // QuerySystemInformation - Provide system-wide information.
    //
    // Clients use this function to check current system information, such as
    // physical memory size, number of processors, etc. Through these information
    // client can optimize their code or change behaviour accordingly.
    //***************************************************************************
    STDMETHOD ( QuerySystemInformation ) ( THIS_ CTDWORD dwType, CTBYTE * pData, CTULONG * pcbSize ) PURE;
};



typedef IasSystem3 * PASSYSTEM3;


#define IMP_IasSystem3 \
IMP_IasSystem2; \
STDMETHODIMP CreateNonCriticalTimeout ( OSTIMEOUTHANDLE *retHandle );\
STDMETHODIMP DestroyNonCriticalTimeout ( OSTIMEOUTHANDLE );\
STDMETHODIMP ScheduleNonCriticalTimeout ( OSTIMEOUTHANDLE hTimeout,  PFCALLBACK pfCallback, CTHANDLE hUser, CTDWORD dwMillisecs );\
STDMETHODIMP QuerySystemInformation ( CTDWORD dwType, CTBYTE * pData, CTULONG * pcbSize )

#define IASSYSTEM_EXPERIMENTAL

#undef  INTERFACE
#define INTERFACE IasSystem4
//*****************************************************************************
// IasSystem4
//*****************************************************************************
DECLARE_INTERFACE_( IasSystem4, IasSystem3 )
{
    //**************************************************************************
    // MapDeviceMemory - Map a portion of a device's memory-mapped address space
    // into the the system's address space.  Once this function is called, the
    // standard page methods (GetPageVirtAddr, GetPagePhysAddr, GetPageBusAddr,
    // GetPageUserModeVirtAddr, GetPageRangeSize) may be applied to the returned
    // OSPHYSMEMHDL.  Note that Device memory is always implicitly locked, so
    // it is neither necessary nor legal to call the Lock and Unlock routines.
    //
    // PARAMETERS:
    //  pDevice -- A pointer to the device that owns the memory window.
    //  baseVirtualAddr -- The virtual address of the first byte of the memory
    //      window.
    //  baseBusAddr -- The bus address of the first byte of the memory.
    //  offset -- The offset from the beginning of the memory window at which 
    //      mapping should start.
    //  numBytes -- The number of bytes to be mapped.
    //  bIsCacheable -- A flag indicating whether to enable caching for the new mapping.
    //    
    // This method can be used for a variety of purposes; it can be used to
    // map control registers into the user address space.  It can be used to map
    // a device's control registers into user address space.  It can be used to
    // map portions of a device's memory into user address space.
    //
    STDMETHOD_( OSPHYSMEMHDL, MapDeviceMemory ) (THIS_ interface ICtDevice *pDevice, CTPTRSIZE baseVirtualAddr, CTPTRSIZE baseBusAddr, CTDWORD offset, 
        CTDWORD numBytes, CTBOOL bIsCacheable) PURE;
    //**************************************************************************
    // SetTimerResolution - This function set the timer resolution
    //
    // PARAMETERS:
    //  ulTimeIn100nsUnits -- The amount of time that should elapse between each timer interrupt, 
    //      in 100 nanosecond units. The minimum value is approximately 10,000 (1 millisecond)
    //      but can vary slightly by platform. (This parameter is ignored if bSetResolution is FALSE.)
    //  bSetResolution -- If TRUE, the call is a request to set the clock interrupt frequency to the value
    //      specified by ulTime. If FALSE, the call is a request to restore the clock interrupt frequency
    //      to the system's default value, which is platform-specific.
    //
    STDMETHOD_( CTULONG, SetTimerResolution ) ( THIS_ CTULONG ulTimeIn100nsUnits, CTBOOL bSetResolution ) PURE;
    //**************************************************************************
    // QueryPerformanceCounter - This routine provides the finest grained running count available in the system
    //
    // PARAMETERS:
    //  pllPerformanceFrequency -- Optionally specifies a pointer to a variable that receives the performance
    //     counter frequency., 
    //
    STDMETHOD_( CTLONGLONG, QueryPerformanceCounter ) (THIS_ PCTLONGLONG pllPerformanceFrequency) PURE;
    //**************************************************************************
    // DelayExecutionThread - This puts the current thread into wait state for a given interval
    //
    // PARAMETERS:
    //  llDelayIntervalIn100nsUnits -- Specifies the absolute or relative time, in units of 100 nanoseconds,
    //     for which the wait is to occur
    //  bRelAbs -- 0 = Relative Time, 1 = Absolute Time
    //
    STDMETHOD ( DelayExecutionThread ) ( THIS_ CTLONGLONG llDelayIntervalIn100nsUnits, CTBOOL bRelAbs ) PURE;

    // MapSystemMemory - Map a virtual address into the kernel/user address space.
	//
	// PARAMETERS:
	//  pVirtualAddress -- Virtual address of the memory to be mapped.
	//  dwSize -- Size of the memory to be mapped.
	//  bKernelAddress -- Which address space pVirtualAddress comes from. TRUE if
	//		pVirtualAddress is a kernel mode address, FALSE otherwise.
	//  bAccessMode -- Specifies the access mode to probe the arguments. TRUE for
	//		kernel mode, FALSE for user mode.
	//	fAccessRights -- Specifies the type of operation for which caller wants the
	//		access probed and the pages locked, either CT_MEMORY_ACCESS_READ,
	//		CT_MEMORY_ACCESS_WRITE or CT_MEMORY_ACCESS_MODIFY.
	//
	// This method can be used to map user-mode memory into the kernel address space.
	//
	STDMETHOD_( OSPHYSMEMHDL, MapSystemMemory ) (THIS_ CTVOID * pVirtualAddress, CTDWORD dwSize, CTBOOL bKernelAddress, CTBOOL bAccessMode, CTDWORD fAccessRights) PURE;
    
};

typedef IasSystem4 * PASSYSTEM4;

#define IMP_IasSystem4 \
    IMP_IasSystem3; \
    STDMETHODIMP_(OSPHYSMEMHDL) MapDeviceMemory(interface ICtDevice * pDevice, CTPTRSIZE baseVirtualAddr, CTPTRSIZE baseBusAddr, CTDWORD offset, CTDWORD numBytes, CTBOOL bCacheable);\
    STDMETHODIMP_(CTULONG) SetTimerResolution ( CTULONG ulTimeIn100nsUnits, CTBOOL bSetResolution );\
    STDMETHODIMP_(CTLONGLONG) QueryPerformanceCounter ( PCTLONGLONG pllPerformanceFrequency );\
    STDMETHODIMP DelayExecutionThread ( CTLONGLONG llDelayIntervalIn100nsUnits, CTBOOL bRelAbs );\
    STDMETHODIMP_(OSPHYSMEMHDL) MapSystemMemory(CTVOID * pVirtualAddress, CTDWORD dwSize, CTBOOL bKernelAddress, CTBOOL bAccessMode, CTDWORD  fAccessRights);

#undef  INTERFACE
#define INTERFACE IasSystem5
//*****************************************************************************
// IasSystem5
//*****************************************************************************
DECLARE_INTERFACE_( IasSystem5, IasSystem4 )
{
    /** GetCurrentThreadId. Callers of GetCurrentThreadId can be running at any IRQL.
      *returns the thread ID of the current thread. 
      */
    STDMETHOD_( CTHANDLE, GetCurrentThreadId) (THIS) PURE;

    //************************************************************************
    //                     Re-entrant Spinlock Functions
    //
    // Spinlocks can only be used by pagelocked code. In the case of NT,
    // acquiring a spinlock will automatically raise the IRQL to  xxxxxxx,
    // Re-entrant spinlocks allow the same thread to reacquire the lock.
    //
    //************************************************************************
    STDMETHOD( CreateThreadSpinLock  ) ( THIS_ OSSPINLOCKHDL* phSpinlock, interface ICtDevice * device ) PURE;
    STDMETHOD( DestroyThreadSpinLock ) ( THIS_ OSSPINLOCKHDL  hSpinlock) PURE;
    STDMETHOD( AcquireThreadSpinLock ) ( THIS_ OSSPINLOCKHDL  hSpinlock) PURE;
    STDMETHOD( ReleaseThreadSpinLock ) ( THIS_ OSSPINLOCKHDL  hSpinlock) PURE;
};

typedef IasSystem5 * PASSYSTEM5;

#define IMP_IasSystem5 \
    IMP_IasSystem4; \
    STDMETHOD_( CTHANDLE, GetCurrentThreadId ) ();\
    STDMETHOD( CreateThreadSpinLock  ) ( OSSPINLOCKHDL* phSpinlock, interface ICtDevice * device );\
    STDMETHOD( DestroyThreadSpinLock ) ( OSSPINLOCKHDL  hSpinlock) ;\
    STDMETHOD( AcquireThreadSpinLock ) ( OSSPINLOCKHDL  hSpinlock) ;\
    STDMETHOD( ReleaseThreadSpinLock ) ( OSSPINLOCKHDL  hSpinlock) ;

#undef  INTERFACE
#define INTERFACE   IasSystem6
//*****************************************************************************
// IasSystem6
//*****************************************************************************
DECLARE_INTERFACE_( IasSystem6, IasSystem5 )
{

//Windows Kernel function that we are wrapping
//1. LONG KeSetEvent(IN PRKEVENT  Event, IN KPRIORITY  Increment, IN BOOLEAN  Wait);

//2. VOID ObDereferenceObject(IN PVOID  Object);

/*3. NTSTATUS  ObReferenceObjectByHandle(IN HANDLE  Handle,
                                         IN ACCESS_MASK  DesiredAccess,
                                         IN POBJECT_TYPE  ObjectType  OPTIONAL,
                                         IN KPROCESSOR_MODE  AccessMode,
                                         OUT PVOID  *Object,
                                         OUT POBJECT_HANDLE_INFORMATION  HandleInformation  OPTIONAL);
*/

//
// Priority increment when no I/O has been done.  This is used by device
// and file system drivers when completing an IRP (IoCompleteRequest).
//
// #define IO_NO_INCREMENT                 0
    STDMETHOD_(CTLONG, SetEvent) ( THIS_ CTHANDLE hEvent, CTDWORD dwPriority, CTBOOL bWait) PURE;

    STDMETHOD_(CTVOID, DereferenceObject) ( THIS_ CTHANDLE hObject) PURE;

    STDMETHOD(ReferenceObjectByHandle) ( THIS_ CTHANDLE hHandle, CTDWORD dwAccessMask, CTVOID * pObjType, CTDWORD dwAccessMode, CTVOID** ppReturnObj) PURE;
    
};

typedef IasSystem6 * PASSYSTEM6;

#define IMP_IasSystem6 \
    IMP_IasSystem5; \
    STDMETHOD_(CTLONG, SetEvent) ( THIS_ CTHANDLE hEvent, CTDWORD dwPriority, CTBOOL bWait);\
    STDMETHOD_(CTVOID, DereferenceObject) ( THIS_ CTHANDLE hObject);\
    STDMETHOD(ReferenceObjectByHandle) ( THIS_ CTHANDLE, CTDWORD dwAccessMask, CTVOID * pObjType, CTDWORD dwAccessMode, CTVOID** ppReturnObj);


#endif //_IASSYSTEM_H
