/**
*******************************************************************************
Confidential & Proprietary
Private & Confidential
Creative Confidential
*******************************************************************************
*/
/**
*******************************************************************************
Copyright (C) 2007, Creative Technology Ltd. All Rights Reserved.
*******************************************************************************
*/
#ifndef _IHWREG
#define _IHWREG

#include "ctdef.h"
#include "ctcomdef.h"

//***********************
// Typedefs and defines
//***********************

//**************************************************************************/
// The following routines read values from a specified I/O
// port.  The assumption these routines make is that OSREGBASE
// specifies the device-dependent base address and incorporates
// any other needed data such as bus number, etc.
//**************************************************************************/

// {F6CA5C22-E161-11d2-9EEF-00C0F02DD390}
DEFINE_GUID(IID_IhwReg, 0xf6ca5c22, 0xe161, 0x11d2, 0x9e, 0xef, 0x0, 0xc0, 0xf0, 0x2d, 0xd3, 0x90);

#undef INTERFACE
#define INTERFACE IhwReg

DECLARE_INTERFACE_( IhwReg, ICtNondelegatingUnknown )
{
    // ICtNondelegatingUnknown
    IMP_ICTNONDEL;

    // hwReg methods
    STDMETHOD_( CTBYTE,  ReadPortByte  ) ( THIS_  CTHANDLE addr ) PURE;
    STDMETHOD_( CTWORD,  ReadPortWord  ) ( THIS_  CTHANDLE addr ) PURE;
    STDMETHOD_( CTDWORD, ReadPortDword ) ( THIS_  CTHANDLE addr ) PURE;

    STDMETHOD_( CTVOID, WritePortByte  ) ( THIS_ CTHANDLE addr, CTBYTE byValue  ) PURE;
    STDMETHOD_( CTVOID, WritePortWord  ) ( THIS_ CTHANDLE addr, CTWORD wValue   ) PURE;
    STDMETHOD_( CTVOID, WritePortDword ) ( THIS_ CTHANDLE addr, CTDWORD dwValue ) PURE;

};

typedef IhwReg * PHWREG;

#define IMP_IhwReg \
IMP_DECL_ICTNONDEL;\
STDMETHODIMP_( CTBYTE  ) ReadPortByte(  CTHANDLE addr );\
STDMETHODIMP_( CTWORD  ) ReadPortWord(  CTHANDLE addr );\
STDMETHODIMP_( CTDWORD ) ReadPortDword( CTHANDLE addr );\
STDMETHODIMP_( CTVOID ) WritePortByte(  CTHANDLE addr, CTBYTE byValue );\
STDMETHODIMP_( CTVOID ) WritePortWord(  CTHANDLE addr, CTWORD wValue  );\
STDMETHODIMP_( CTVOID ) WritePortDword( CTHANDLE addr, CTDWORD dwValue )


#endif







