/**
*******************************************************************************
Confidential & Proprietary
Private & Confidential
Creative Confidential
*******************************************************************************
*/
/**
*******************************************************************************
Prototypes for floating point library functions on the Intel Pentium processor
Copyright (C) 2007, Creative Technology Ltd. All Rights Reserved.
*******************************************************************************
*/

#ifndef __x86math_h
#define __x86math_h

#include "ctdef.h"

#ifdef __cplusplus
extern "C" {
#endif

double fp_acos(double);
double fp_asin(double);
double fp_atan(double);
double fp_atan2(double, double);
double fp_cos(double);
double fp_exp(double);
double fp_fmod(double, double);
double fp_log(double);
double fp_log10(double);
double fp_pow(double, double);
double fp_sin(double);
double fp_tan(double);
double fp_sqrt(double);
double fp_ceil(double);
double fp_floor(double);
double fp_ldexp(double, int);
void   fp_SaveFPU(void *) __attribute__ ((regparm (0)));
void   fp_RestoreFPU(void *) __attribute__ ((regparm (0)));
double fp_fabs(double);
double fp_cosh(double);
double fp_sinh(double);
double fp_tanh(double);
double fp_frexp(double, int *);
double fp_modf(double, double *);

#if CT_IS_WINDOWS
    __int64 _ftol();
#endif

#define FPUBUFSIZE 112

#ifdef __cplusplus
}
#endif

#endif

