/**
*******************************************************************************
Confidential & Proprietary
Private & Confidential
Creative Confidential
*******************************************************************************
*/
/**
*******************************************************************************
Main code module for haxfi
Copyright (C) 2008, Creative Technology Ltd. All Rights Reserved.
*******************************************************************************
*/

#define __NO_VERSION__
#define EXPORT_SYMTAB
#include <linux/module.h>
#include <linux/version.h>
#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 19)
#include <linux/config.h>
#endif
#include <asm/types.h>

#include "haxfi.h"
//#include "IasOSSrv.h"

// Extern global variables
INSERT_VERSION_INFO;

// Static global variables
IasOSSrv *g_pIasOSSrv = NULL;
static ICtUnknown *g_pICtUnk = NULL;
static CTBOOL s_haxfi_Initialized = FALSE;

// Exported function
CTHANDLE 
get_ha(void)
{
    return ((CTHANDLE)g_pICtUnk);
}
CT_EXPORT_SYMBOL_NOVERS(get_ha);


////////////////////
// unicode helpers
////////////////////
typedef __u16 wchar_t;

struct utf8_table {
    int     cmask;
    int     cval;
    int     shift;
    long    lmask;
    long    lval;
};

static struct utf8_table utf8_table[] =
{
    {0x80,  0x00,   0*6,    0x7F,           0,         /* 1 byte sequence */},
    {0xE0,  0xC0,   1*6,    0x7FF,          0x80,      /* 2 byte sequence */},
    {0xF0,  0xE0,   2*6,    0xFFFF,         0x800,     /* 3 byte sequence */},
    {0xF8,  0xF0,   3*6,    0x1FFFFF,       0x10000,   /* 4 byte sequence */},
    {0xFC,  0xF8,   4*6,    0x3FFFFFF,      0x200000,  /* 5 byte sequence */},
    {0xFE,  0xFC,   5*6,    0x7FFFFFFF,     0x4000000, /* 6 byte sequence */},
    {0,                            /* end of table    */}
};

int
utf8_mbtowc(wchar_t *p, const __u8 *s, int n)
{
    long l;
    int c0, c, nc;
    struct utf8_table *t;

    nc = 0;
    c0 = *s;
    l = c0;
    for (t = utf8_table; t->cmask; t++) {
        nc++;
        if ((c0 & t->cmask) == t->cval) {
            l &= t->lmask;
            if (l < t->lval)
                return -1;
            *p = l;
            return nc;
        }
        if (n <= nc)
            return -1;
        s++;
        c = (*s ^ 0x80) & 0xFF;
        if (c & 0xC0)
            return -1;
        l = (l << 6) | c;
    }

    return -1;
}

int
mbstowcs(wchar_t *pwcs, CTCHAR *s, int n)
{
    __u16 *op;
    const __u8 *ip;
    int size;

    op = pwcs;
    ip = (__u8 *)s;
    while (*ip && n > 0) {
        if (*ip & 0x80) {
            size = utf8_mbtowc(op, ip, n);
            if (size == -1) {
                /* Ignore character and move on */
                ip++;
                n--;
            } else {
                op++;
                ip += size;
                n -= size;
            }
        } else {
            *op++ = *ip++;
        }
    }
    
    return (op - pwcs);
}


////////////////////
// Entry/Exit points
////////////////////

static int __init
haxfi_init(void)
{
    HRESULT hr;

#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 0)
    EXPORT_NO_SYMBOLS;    
#endif

    // this module have been loaded already
    if (s_haxfi_Initialized) 
        return 0;

    __do_global_ctors_aux();

    // begin with the ha job 
    // Get IasOSSrv interface from ctossrv
    g_pIasOSSrv = (IasOSSrv *)get_ossrv();
    if (!g_pIasOSSrv) {
        PDEBUG("Error: init_module() encountered invalid IasOSSrv pointer\n");
        return -ENODEV;
    }
    PDEBUG("Got IasOSSrv pointer: 0x%p\n",g_pIasOSSrv);    
            
    // Do haCore_InitDriver(OsSrv) staff
    hr = haCore_InitDriver(g_pIasOSSrv);
    if (FAILED(hr)) {
        PDEBUG("Error: init_module() could not initialize hardware core\n");
        haCore_ExitDriver();
        return -ENODEV;
    }
    // end haCore... 
    
    PDEBUG("haxfi.o has been loaded.\n");
    s_haxfi_Initialized = TRUE;
                
    return 0;
}

static void __exit
haxfi_exit(void)
{

    PDEBUG("Undiscovering haCore\n");
    haCore_ExitDriver();

    PDEBUG("haxfi.o has beed unloaded.\n");
    s_haxfi_Initialized = FALSE;
}

module_init(haxfi_init);
module_exit(haxfi_exit);

MODULE_AUTHOR("Copyright (C) 1999-2008 Creative Technology Ltd");
MODULE_DESCRIPTION("HAXFI driver version 1.18.0000");
MODULE_LICENSE("Creative Proprietary License");

