/**
*******************************************************************************
Confidential & Proprietary
Private & Confidential
Creative Confidential
*******************************************************************************
*/
/**
*******************************************************************************
Main code module for PIA plugins
Copyright (C) 2008, Creative Technology Ltd. All Rights Reserved.
*******************************************************************************
*/

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/slab.h>
#include <linux/vmalloc.h>

#include "PluginLinux.h"
#include "plugindll.h"
#include "osutils.h"

#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,18)) || (HAVE_UTSRELEASE_H == 1)
#include <linux/utsrelease.h>
#endif

char kernel_version[] = UTS_RELEASE;

static CTDWORD g_dwRef = 0;

CTDWORD PluginAddRef(void)
{
    return ++g_dwRef;
}

CTDWORD PluginRelease(void)
{
    return --g_dwRef;
}

#if LINUX_VERSION_CODE < KERNEL_VERSION(2, 6, 0)
CT_EXPORT_NO_SYMBOLS;
#endif

extern void __do_global_ctors_aux();

static int __init
plugin_init(void)
{
    PLUGINNODE plugin;

    CTDPF("Module loaded");

    __do_global_ctors_aux();

    strcpy(plugin.szName, g_szPluginName);
    plugin.pfnDllCanUnloadNow = DllCanUnloadNow;
    plugin.pfnDllAdviseIfCanUnload = DllAdviseIfCanUnload;
    plugin.pfnDllGetClassObject = DllGetClassObject;
    plugin.pfnDllEnumCLSIDs = DllEnumCLSIDs;
    plugin.pfnDllEnumDefaultStrings = DllEnumDefaultStrings;
    plugin.pfnDllEnumDefaultUnits = DllEnumDefaultUnits;
    plugin.pfnPluginAddRef = PluginAddRef;
    plugin.pfnPluginRelease = PluginRelease;
    plugin.pNext = NULL;

    if (FAILED(register_plugin(&plugin)))
        return -ENODEV;

    return DllMain(0, DLL_PROCESS_ATTACH, NULL) ? 0 : -ENODEV;
}

static void __exit
plugin_exit(void)
{
    CTDPF("Module unloaded");

    unregister_plugin(g_szPluginName);
    DllMain(0, DLL_PROCESS_DETACH, NULL);
}

module_init(plugin_init);
module_exit(plugin_exit);

MODULE_AUTHOR("Copyright (C) 1999-2008 Creative Technology Ltd");
MODULE_DESCRIPTION("EMUPIA Plugin version 1.18.0000");
MODULE_LICENSE("Creative Proprietary License");

